;*=====================================================================*/
;*    .../project/hop/weblets/hyphenator-api/hyphenator-api.scm        */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Dec 22 05:15:34 2009                          */
;*    Last change :  Wed May 26 14:38:35 2010 (serrano)                */
;*    Copyright   :  2009-10 Manuel Serrano                            */
;*    -------------------------------------------------------------    */
;*    Client side declaration of Hyphenator                            */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module hyphenator-api_client
   (export (document-hyphenate #!optional lang)
	   (node-hyphenate node)
	   (hyphenator-config . l))
   (JS Hyphenator))

;*---------------------------------------------------------------------*/
;*    The head                                                         */
;*---------------------------------------------------------------------*/
(<HEAD> :jscript "Hyphenator.js")

;*---------------------------------------------------------------------*/
;*    document-hyphenate ...                                           */
;*---------------------------------------------------------------------*/
(define (document-hyphenate #!optional lang)
   ;; when specified, set the language
   (when (string? lang)
      (let ((els (dom-get-elements-by-tag-name "html")))
	 (when (pair? els)
	    (let ((el (car els)))
	       (set! el.lang lang)))))
   ;; run the hyphenator
   (add-event-listener! window "ready" (lambda (_) (Hyphenator.run #t))))

;*---------------------------------------------------------------------*/
;*    node-hyphenate ...                                               */
;*---------------------------------------------------------------------*/
(define (node-hyphenate node)
   ;; hyphenate a node with the current language
   (Hyphenator.hyphenate node #f))

;*---------------------------------------------------------------------*/
;*    hyphenator-config ...                                            */
;*---------------------------------------------------------------------*/
(define (hyphenator-config . l)
   (when (pair? l) (Hyphenator.config (plist->jsobject l)))
   (jsobject->plist (Hyphenator.config)))
